uniform float weightingFact;
// Ambient and diffuse scale factors.
const float As = 1.0 / 1.5;
const float Ds = 1.0 / 2.5;
const float Accessibility = 0.4;

void  main(void)
{
    vec4 ecPosition = gl_ModelViewMatrix * gl_Vertex;
    vec3 ecPosition3 = (vec3(ecPosition)) / ecPosition.w;
    vec3 VP = vec3(gl_LightSource[0].position) - ecPosition3;
    VP = normalize(VP);
    vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
    float diffuse = max(0.0, dot(normal, VP));

    float scale = min(1.0, Accessibility * As + diffuse * Ds);

    //gl_FrontColor  = vec4(scale* gl_Color.rgb, gl_Color.a);
   
	vec4 keyFrameA_vert = gl_Vertex;
	vec3 keyFrameA_norm = gl_Normal;
	
	// pass keyframe B vertex attributes
	vec4 keyFrameB_vert = gl_MultiTexCoord6;
	
	// linear interpolation
	// blendedPos_vert = (1.0-weightingFact) * keyFrameA_vert + weightingFact * keyFrameB_vert
	vec4 blendedPos_vert = mix( keyFrameA_vert,
								keyFrameB_vert,
								weightingFact );

	// pass texture coordinates as always
	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_FrontColor = gl_Color;
	
	//transform blended vertex to homogeneous clip space
	gl_Position = gl_ModelViewProjectionMatrix * blendedPos_vert;
}