uniform sampler2DShadow ShadowMap;
uniform sampler2DShadow ShadowMap2;
uniform sampler2D bodenMap;
uniform vec3 farbe1;
uniform vec3 farbe2;
uniform vec3 farbe3;
uniform vec3 farbe4;
uniform float grenze1;
uniform float grenze2;
uniform float range;

uniform float Epsilon;

varying vec4 ShadowCoord1;
varying vec4 ShadowCoord2;
varying vec3 vertexPos;
varying float scale;

float Illumination;

float lookup2(float x, float y)
{
    float depth = shadow2D(ShadowMap2, 
                       ShadowCoord2 + vec4(x, y, 0, 0) * Epsilon).x;
    return depth != 1.0 ? 0.4 : 1.0;
}
float lookup1(float x, float y)
{
    float depth = shadow2D(ShadowMap, 
                       ShadowCoord1 + vec4(x, y, 0, 0) * Epsilon).x;
    return depth != 1.0 ? 0.4 : 1.0;
}

vec3 calcColor(float height)
{
	double puffer;

	if (height < (grenze1 - range/2))
	{
		return farbe1;
	}
	else if (height < (grenze1 + range/2))
	{
		puffer = (height - grenze1 + range/2) / range;
		return (farbe1*(1-puffer) + farbe2*puffer);
	}
	else if (height < (grenze2 - range/2))
	{
		puffer = (height - grenze1-range/2) / (grenze2-grenze1-range);
		return (farbe2*(1-puffer) + farbe3*puffer);
		//return farbe3;
	}
	else if (height < (grenze2 + range/2))
	{
		puffer = (height - grenze2 + range/2) / range;
		return farbe3*(1-puffer) + farbe4*puffer;
	}
	else
	{
		return farbe4;
	}
}

void main()
{
    float sum = 0.0;
	float sum2 = 0.0;
    sum += lookup1(-0.5, -0.5);
    sum += lookup1( 0.5, -0.5);
    sum += lookup1(-0.5,  0.5);
    sum += lookup1( 0.5,  0.5);
    sum2 += lookup2(-0.5, -0.5);
    sum2 += lookup2( 0.5, -0.5);
    sum2 += lookup2(-0.5,  0.5);
    sum2 += lookup2( 0.5,  0.5);
   
   	vec4 texture = texture2D(bodenMap,gl_TexCoord[0].xy);
	//if (vertexPos.y < 7.0)
	
	gl_Color = vec4(calcColor(vertexPos.y)*scale, gl_Color.a);
		
    vec4 shadow = vec4(sum *0.25 * sum2 * 0.25 * gl_Color.rgb, gl_Color.a);
	gl_Color *= texture*0.8+shadow*2.2;
	gl_FragColor = clamp(gl_Color,0.0,1.3);
	
	/*float Z = gl_ProjectionMatrix[3].z/(gl_FragCoord.z * -2.0 + 1.0 - gl_ProjectionMatrix[2].z);
	
	gl_FragColor.r = Z;*/
	//gl_FragColor.r = gl_FragColor.b;
    //gl_FragColor = texture;
}