uniform sampler2D BumpMap;
uniform sampler2D RefractionMap;
uniform sampler2D ReflectionMap;

void main(void)
{
vec3 vEye = normalize(gl_TexCoord[0]).xyz;

vec3 vBumpTexA = texture2D(BumpMap, gl_TexCoord[1].xy).xyz;
vec3 vBumpTexB = texture2D(BumpMap, gl_TexCoord[2].xy).xyz;
vec3 vBumpTexC = texture2D(BumpMap, gl_TexCoord[3].xy).xyz;
vec3 vBumpTexD = texture2D(BumpMap, gl_TexCoord[4].xy).xyz;

vec3 vBumpTex = normalize(2.0 * (vBumpTexA.xyz + vBumpTexB.xyz + vBumpTexC.xyz + vBumpTexD.xyz)-4.0);

vec3 vRefrBump = vBumpTex.xyz * vec3(0.05, 0.05, 1.0);
vec3 vReflBump = vBumpTex.xyz * vec3(0.1, 0.1, 1.0);

vec2 vProj = (gl_TexCoord[5].xy/gl_TexCoord[5].w);

vec4 vReflection = texture2D(ReflectionMap, vProj.xy + vReflBump.xy);

vec4 vRefrA = texture2D(RefractionMap, vProj.xy + vRefrBump.xy);
vec4 vRefraction = vRefrA;//mix( vRefrA, vRefrB , vRefrA.w);

float NdotL = max( dot(vEye, vReflBump), 0.0);
float facing = (1.0 - NdotL);
float fresnel = max( 0.2 + 0.8 * pow(facing, 5.0), 0.0 );

float fDistScale = clamp( gl_TexCoord[5].z / gl_TexCoord[1].w, 0.0, 1.0 );
vec3 WaterDeepColor = mix( vec3(0.0, 0.05, 0.25), vRefraction.xyz, fDistScale*3.8 );

vec3 WaterColor = vec3(0.0, 0.1, 0.15);
vec3 White = vec3(1.0, 1.0, 1.0);
vec3 waterColor = mix ( WaterDeepColor, WaterColor, facing );
vec3 cReflect = (fresnel * vReflection).xyz;

vec3 temp = cReflect*0.3 + WaterDeepColor*0.7;// + pow(1-fresnel,0.5)*White;
gl_FragColor.xyz = clamp(temp,0.0,1.0);
gl_FragColor.w = 1.0;
}
